package jrf.hbset.util;

public class MyMap<K,V>  { //extends HashMap<K,V> {
	
	static final int CAPACITY = 3;
	Entry<K,V>[] element;
	
	
	public MyMap()
	{
		this(CAPACITY);
	}
	
	public MyMap(int capacity)
	{
		element = new Entry[capacity];
	}
	
	public int size()
	{
		for (int i=0 ; i < element.length ; ++i)
			if ( element[i] == null ) return (i+1);
		return element.length;
	}
	
	public MyMap<K,V> clone()
	{
		MyMap<K,V> clone = new MyMap<K,V>(element.length);
		
		for (Entry<K,V> n : element)
		{
			if ( n != null )
				clone.put(n.key, n.value);
		}
		
		return clone;
	}
	
	public V put(K key, V value) {

		for (int i=0 ; i < element.length ; ++i)
		{
			if ( element[i] == null )
			{
				element[i] = new Entry<K,V>(key, value);
				return null;
			}
			else if ( element[i].key.equals(key) )
			{
				V old = element[i].value;
				element[i].value = value;
				return old;
			}
		}
		
		Entry<K,V>[] expand = new Entry[element.length+CAPACITY];
		for ( int i=0 ; i < element.length ; ++i)
			expand[i] = element[i];
		expand[element.length] = new Entry<K,V>(key, value);
		element = expand;
		return null;
	}
	
	public V get(K key) {
		
		for (int i=0 ; i < element.length ; ++i)
		{
			if ( element[i] == null )
				return null;
				
			else if ( element[i].key.equals(key) )
				return element[i].value;
		}
		return null;
	}
	
	public boolean containsKey(K key) {
		if ( get(key) != null )
			return true;
		else
			return false;
	}
	
	public V remove(K key) {
		int p=-1, end=element.length;
		for (int i=0 ; i < element.length ; ++i)
		{
			if ( element[i] == null )
			{
				end = i;
				break;
			}
			else if ( element[i].key.equals(key) )
				p = i;
		}
		if ( p != -1 )
		{
			V old = element[p].value;
			element[p].key = element[end-1].key;
			element[p].value = element[end-1].value;
			element[end-1] = null;
			return old;
		}
		return null;
    }
	
	public MySet<K> keySet()
	{	
		MySet<K> set = new MySet<K>();
		
		for ( int i=0 ; i < element.length ; ++i)
		{
			if ( element[i] != null ) set.add(element[i].key);
			else break;
		}
		return set;
	}
	
	class Entry<KK, VV> {
		 KK key;
		 VV value;
		
		Entry(KK key, VV value)
		{
			this.key = key;
			this.value = value;
		}
	}
}