package jrf.hbset.util;

import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.List;
import java.util.Iterator;

import jrf.hbset.util.Utility.Comparison;

public class BitVectorHBSet implements HBSet  {
	static final int INITIAL_VOLATILE=29;
	static final int INITIAL_NON_VOLATILE=1280;
	static final int UNIT=512;
	int row_index=0;
	int column_index=0;
	
	int row_size=INITIAL_VOLATILE;
	int column_size=INITIAL_NON_VOLATILE;
	
	byte[][] hb=new byte[INITIAL_VOLATILE][];
	//Key[] hash = new Key[INITIAL];
	
	Key[] hb_row = new Key[INITIAL_VOLATILE];
	Key[] hb_column = new Key[INITIAL_NON_VOLATILE];
	
	Key[] written_by = new Key[INITIAL_NON_VOLATILE];
	Key[] prior_release = new Key[INITIAL_VOLATILE];
	
	/*
	 * GET CURRENT HB TO ARRAY REPRESENTATION
	 */
	/*
	public Comparison compare(HBSet other)
	{
		Set<Key> my_volatiles = get_volatiles();
		Set<Key> other_volatiles = ((BitVectorHBSet)other).get_volatiles();
		
		boolean bigger = true;
		boolean smaller = true;
		
		if ( Utility.compare(my_volatiles, other_volatiles) == Comparison.NONE )
			return Comparison.NONE;
		
		Iterator<Key> it = my_volatiles.iterator();
		while ( it.hasNext() )
		{
			Key k = it.next();
			if ( !other_volatiles.contains(k) )
				smaller = false;
			else
			{
				Set<Key> mine = get_hb_set(k);
				Set<Key> others = other.get_hb_set(k);
				if ( !mine.containsAll(others) )
				{
					bigger = false;
				}
				if ( !others.containsAll(mine) )
				{
					smaller = false;
				}
			}
			if ( !smaller && !bigger )
				return Comparison.NONE;
		}
		if ( !my_volatiles.containsAll(other_volatiles) )
			bigger = false;
		if ( smaller )
		{
			if ( bigger ) return Comparison.EQUAL;
			else return Comparison.SMALLER;
		}
		return Comparison.BIGGER;
	}
	
	private Set<Key> get_volatiles()
	{
		MySet<Key> set = new MySet<Key>(row_index);
		for (int i=0 ; i < row_index ; ++i)
		{
			set.add(hb_row[i]);
		}
		return set;
	}
	/*
	private int[] bytearray_to_intarray(byte[] ba) 
	{
		if ( ba == null )
		{
			int[] ia = new int[1];
			ia[0] = 0;
			return ia;
		}
		
		int size = (ba.length+3)/4+1;
		int[] ia = new int[size];
		ia[0] = ba.length;
		for ( int i=1; i < size ; ++i)
		{
			int ival = ba[(i-1)*4]<<24;
			if ( (i-1)*4+1 < ba.length ) ival |= (ba[(i-1)*4+1]&0xff)<<16;
			if ( (i-1)*4+2 < ba.length ) ival |= (ba[(i-1)*4+2]&0xff)<<8;
			if ( (i-1)*4+3 < ba.length ) ival |= (ba[(i-1)*4+3]&0xff);		
			ia[i] = ival;
		}
		return ia;
	}
	
	public int[] get_serialized_hb()
	{
		int size = 5;//row_index,column_index,row_size,column_size, hb.length;
		
		int[][] hb_serialize = new int[hb.length][];
		for ( int i=0 ; i < hb.length ; ++i )
		{
			hb_serialize[i] = bytearray_to_intarray(hb[i]);
			size += hb_serialize[i].length;
		}
		
		size += hb_row.length*2+1;
		size += hb_column.length*2+1;
				   
		int[] buf = new int[size];
		int buf_index=0;
		
		buf[buf_index++] = row_index; // 0
		buf[buf_index++] = column_index; // 1
		buf[buf_index++] = row_size; // 2
		buf[buf_index++] = column_size; // 3
		
		// copy hb
		buf[buf_index++] = hb_serialize.length; // 4	
		for ( int i=0 ; i < hb_serialize.length ; ++i )
		{
			System.arraycopy(hb_serialize[i], 0, buf, buf_index, hb_serialize[i].length);
			buf_index += hb_serialize[i].length;
		}
		
		// copy hb_row
		buf[buf_index++] = hb_row.length;
		for ( int i=0 ; i <hb_row.length ; ++i )
		{
			buf[buf_index++] = hb_row[i]==null?0:hb_row[i].obj;
			buf[buf_index++] = hb_row[i]==null?0:hb_row[i].field;
		}
		
		// copy hb_column
		buf[buf_index++] = hb_column.length;
		for ( int i=0 ; i <hb_column.length ; ++i )
		{
			buf[buf_index++] = hb_column[i]==null?0:hb_column[i].obj;
			buf[buf_index++] = hb_column[i]==null?0:hb_column[i].field;
		}
		
		assert (buf_index == size):"Invalid int[] buffer allocated. ("+buf_index+" != "+size+")";
		return buf;
	}
	*/
	
	
	/*
	 * GET CURRENT HB INFORMATION
	 */
	public int[] get_table_entry()
	{
		int[] size = new int[2];
		size[0] = row_index;
		size[1] = column_index;
		return size;
	}
	
	public int get_table_size()
	{
		int size=0;
		for ( int i=0 ; i < row_index ; ++i )
		{
			if ( hb[i] != null )
				size += hb[i].length;
		}
		size += Key.SIZE_OF_KEY*2*(row_size+column_size);
		
		return size;
	}
	
	public boolean is_hb_member(Key o)
	{
		return get_hash_row_index(o)==Log.EMPTY?false:true;
	}
	
	public boolean is_column_member(Key o)
	{
		return get_hash_column_index(o)==Log.EMPTY?false:true;
	}
	
	 public int get_hash_row_index(Key o)
	 {
		for ( int i=0 ; i < row_index ; ++i )
			if ( o.equals(hb_row[i]) ) return i;
		return Log.EMPTY;
	 }
	 
	 public int get_hash_column_index(Key o)
	 {
		for ( int i=0 ; i < column_index ; ++i )
			if ( o.equals(hb_column[i]) ) return i;
		return Log.EMPTY;
	 }
	 
	 public MySet<Key> get_column()
	 {
		 MySet<Key> tmp = new MySet<Key>();
		 for ( Key k : hb_column)
			 if ( k != null ) tmp.add(k);
			 else break;
		 return tmp;
	 }
	 
	 public MySet<Key> get_row()
	 {
		 MySet<Key> tmp = new MySet<Key>();
		 for ( Key k : hb_row)
			 if ( k != null ) tmp.add(k);
			 else break;
		 return tmp;
	 }
	 
	// returns the Keys which has o in their hbSet
	 public MySet<Key> get_key_set(Key o)
	 {
		 
		MySet<Key> tmp = new MySet<Key>();
		
		int obj = get_hash_column_index(o);
		assert(obj != Log.EMPTY):"Cannot find slot for \""+o+"\"";
		
		//tmp.add(o);
		if ( get_hash_column_index(o) != Log.EMPTY )
			 tmp.add(o);
		for ( int i=0 ; i < row_index ; ++i )
		{
			if ( (hb[i] != null) &&
					  (hb[i].length > obj/8) && 
					  ( (hb[i][obj/8] & (byte)(0x80 >> obj%8)) != 0) )
				tmp.add(hb_row[i]);
		}
		 
		return tmp;
	 }
		
	 // returns the hbSet of o
	 public MySet<Key> get_hb_set(Key o)
	 {
		 MySet<Key> tmp = new MySet<Key>();
		 int obj = get_hash_row_index(o);
		 assert(obj != Log.EMPTY):"Cannot find slot for \""+o+"\"";
		 
		 //tmp.add(o);
		 if ( get_hash_column_index(o) != Log.EMPTY )
			 tmp.add(o);
		 if ( hb[obj] != null )
		 {
			 for ( int i=0, hash_index=0 ; i < hb[obj].length ; ++i )
				 for ( int j=0 ; j < 8 ; ++j,++hash_index )
				 {
					 if ( ( hb[obj][i] & (0x80 >> j) ) != 0 ) 
						 tmp.add(hb_column[hash_index]);
				 }
		 }
		 return tmp;
	 }
	
	/*
	 * GET INFORMATION ABOUT HB OPERATION HISTORY
	 */
	public Key get_written_by(Key o)
	{
		Key t=null;
		int entry = get_hash_column_index(o);
		if ( entry != Log.EMPTY ) 
		{
			t = written_by[entry];
		}
		return t;
	}

	public Key set_written_by(Key t, Key o)
	{
		int entry = get_hash_column_index(o);
		assert (entry != Log.EMPTY):"Cannot find slot for "+o;
		Key old = written_by[entry];
		written_by[entry] = t;
		return old;
	}
	
	public Key set_prior_release(Key t, Key o)
	{
		int entry = get_hash_row_index(o);

		assert (entry != Log.EMPTY):"Cannot find slot for \""+o+"\"";
		Key old = prior_release[entry];
		prior_release[entry] = t;
		return old;
	}
	
	public Key get_prior_release(Key o)
	{
		Key t=null;
		int entry = get_hash_row_index(o);
		if ( entry != Log.EMPTY ) 
		{
			t = prior_release[entry];
		}
		return t;
	}
	
	/*
	 * ALLOCATE/DEALLOCATE HB ENTRY
	 */
	public List<KeyPair> allocate(Key o, boolean isVolatile)
	{
		if ( isVolatile )
			return allocate_row(o);
		else
			return allocate_column(o);
	}
	
	List<KeyPair> allocate_row(Key o)
	{
		/* 
		 * this might be because of gc, and then reuse of memory,
		 */
		
		int obj=get_hash_row_index(o);
		
		// reuse 
		if ( obj != Log.EMPTY )
		{
			ArrayList<KeyPair> existing = new ArrayList<KeyPair>();
			// change to this assert version later
			// but this assertion can also be eliminated after ultimate testing
			//assert ( hb[obj] == null ):"ALLOCATION found NOT empty preallocated obj("+o+"="+get_hash(o)+")";
			if ( hb[obj] != null ) 
			{
				//Log.warning("###################################################################");
				//Log.warning("WARNING: hbSet for \""+o+"("+get_hash(o)+")\" is not empty at the time of reuse.");
				//Log.warning("###################################################################");
				MySet<Key> old = get_hb_set(o);
				for ( Key p : old )
					if ( !p.equals(o) ) existing.add(new KeyPair(o, p));
				hb[obj] = null;
			}
			
			// this is necessary for acquore/release through synchronization 
			// but it should be taken care by allocate_column since that will be called at time of object creation
			/*
			Set<Key> b = get_KeySet(o);				
			Iterator<Key> it = b.iterator();
			while ( it.hasNext() )
			{
				Key k = it.next();
				if ( !o.equals(k))
				{
					//Log.warning("###################################################################");
					//Log.warning("WARNING: \""+o+"\" is in the hbSet of \""+k+"\" at reuse time");
					//Log.warning("###################################################################");
					remove(k, o);
					existing.add(new KeyPair(k, o));
				}
			}
			*/
			
			//
			// ?????
			// How about prior_release and written_by ??? do we need to reset this also??? MIGHT BE
			// ?????
			//
			return existing;
		}
		
		// new allocation
		
		// need to increase hb size
		if ( row_index == row_size )
		{
			// increment size with UNIT*8
			row_size += UNIT;
			// extend hb
			byte[][] tmp1 = new byte[row_size][];
			System.arraycopy(hb, 0, tmp1, 0, hb.length);		
			hb = tmp1;
			
			// extend hb_row_index
			Key[] tmp2 = new Key[row_size];
			System.arraycopy(hb_row, 0, tmp2, 0, hb_row.length);
			hb_row = tmp2;
			
			// store at hash table
			hb_row[row_index++] = o;
			
			/*
			// extend written_by
			tmp2 = new Key[size];
			System.arraycopy(written_by, 0, tmp2, 0, written_by.length);
			written_by = tmp2;
			*/
			
			// extend prior_release
			tmp2 = new Key[row_size];
			System.arraycopy(prior_release, 0, tmp2, 0, prior_release.length);
			prior_release = tmp2;
		}
		else
			hb_row[row_index++] = o;
		Log.logHBSet("\t\t<allocate> \""+o+"\" to row slot "+(row_index-1));
		return null;
	}
	
	List<KeyPair> allocate_column(Key o)
	{
		/* 
		 * this might be because of gc, and then reuse of memory,
		 */
		
		int obj=get_hash_column_index(o);
		
		// reuse 
		if ( obj != Log.EMPTY )
		{
			ArrayList<KeyPair> existing = new ArrayList<KeyPair>();
			// change to this assert version later
			// but this assertion can also be eliminated after ultimate testing
			//assert ( hb[obj_row] == null ):"ALLOCATION found NOT empty preallocated obj("+o+"="+get_hash(o)+")";
			/*
			 * this part will be taken care by allocate_row part?? NO
			 */
			int obj_row = get_hash_row_index(o);
			if ( obj_row != Log.EMPTY && hb[obj_row] != null )  // row_entry is allocatd previously & 
			{
				//Log.warning("###################################################################");
				//Log.warning("WARNING: hbSet for \""+o+"("+get_hash(o)+")\" is not empty at the time of reuse.");
				//Log.warning("###################################################################");
				MySet<Key> old = get_hb_set(o);
				for ( Key p : old )
					if ( !p.equals(o) ) existing.add(new KeyPair(o, p));
				hb[obj_row] = null;
			}
			
			// this is necessary for acquore/release through synchronization 
			MySet<Key> b = get_key_set(o);				
			Iterator<Key> it = b.iterator();
			while ( it.hasNext() )
			{
				Key k = it.next();
				if ( !o.equals(k))
				{
					//Log.warning("###################################################################");
					//Log.warning("WARNING: \""+o+"\" is in the hbSet of \""+k+"\" at reuse time");
					//Log.warning("###################################################################");
					remove(k, o);
					existing.add(new KeyPair(k, o));
				}
			}
			return existing;
		}
		
		// new allocation
		
		// need to increase hb size
		if ( column_index == column_size )
		{
			// increment size with UNIT*8
			column_size += UNIT;
			// extend hb
			/*
			byte[][] tmp1 = new byte[column_size][];
			System.arraycopy(hb, 0, tmp1, 0, hb.length);		
			hb = tmp1;
			*/
			
			// extend hb_row_index
			Key[] tmp2 = new Key[column_size];
			System.arraycopy(hb_column, 0, tmp2, 0, hb_column.length);
			hb_column = tmp2;
			
			// store at hash table
			hb_column[column_index++] = o;
			
			
			// extend written_by
			tmp2 = new Key[column_size];
			System.arraycopy(written_by, 0, tmp2, 0, written_by.length);
			written_by = tmp2;
			
			/*
			// extend prior_release
			tmp2 = new Key[row_size];
			System.arraycopy(prior_release, 0, tmp2, 0, prior_release.length);
			prior_release = tmp2;
			*/
		}
		else
			hb_column[column_index++] = o;
		Log.logHBSet("\t\t<allocate> \""+o+"\" to column entry "+(column_index-1));
		return null;
	}
	
	public void deallocate(Key o, boolean isVolatile)
	{
		if ( isVolatile )
			hb[get_hash_row_index(o)] = null;
		else
		{
			MySet<Key> b = get_key_set(o);				
			Iterator<Key> it = b.iterator();
			while ( it.hasNext() )
			{
				Key k = it.next();
				if ( k != o ) 
				{
					remove(k, o);
					Log.logHBSet("\t\t<deallocate> remove \""+o+"\" from "+k);
				}
			}
		}
	}
	
	public BitVectorHBSet clone()
	{
		BitVectorHBSet other = new BitVectorHBSet();
		other.row_index = row_index;
		other.row_size = row_size;
		other.hb_row = hb_row.clone();
		other.prior_release = prior_release.clone();
		
		other.column_index = column_index;	
		other.column_size = column_size;	
		other.hb_column = hb_column.clone();
		other.written_by = written_by.clone();
		
		other.hb = new byte[hb.length][];
		for ( int i=0 ; i < hb.length ; ++i )
		{
			if ( hb[i] != null )
			{
				other.hb[i] = new byte[hb[i].length];
				System.arraycopy(hb[i], 0, other.hb[i], 0, other.hb[i].length);
			}
		}
		return other;
	}
	
	/*
	public void clean(Key o)
	{
		hb[get_hash_row_index(o)] = null;
	}
	*/
	
	/*
	 * ADD/REMOVE TO/FROM HB
	 */
	public void add(Key s, Key o)
	 {
		
		 if ( s.equals(o) )
			 return;

		 
		 byte mask;
		 int set = get_hash_row_index(s);
		 int obj = get_hash_column_index(o);
		 assert(set != Log.EMPTY):"Cannot find slot for \""+s+"\"";
		 assert(obj != Log.EMPTY):"Cannot find slot for \""+o+"\"";
 	 
		 if ( hb[set] != null && hb[set].length > (obj/8) ) 
			 // slot for obj is already allocated
		 {
			 mask = (byte)(0x80 >> obj%8);
			 hb[set][obj/8] |= mask;
		 }
		 else 
		 {
			 byte[] tmp = new byte[obj/8+1];
			 if ( hb[set] != null ) 
				 System.arraycopy(hb[set], 0, tmp, 0, hb[set].length);
			 hb[set] = tmp;
			 int self = get_hash_column_index(o);
			 if ( self != Log.EMPTY && self/8 <= obj/8 )// new allocation, initialize with self if necessary
			 {
				 mask = (byte)(0x80 >> self%8);
				 hb[set][self/8] |= mask;
			 }
			 
			 mask = (byte)(0x80 >> obj%8);
			 hb[set][obj/8] |= mask;			 
		 }

	 }
	 
	public void remove(Key s, Key o)
	 {
		 //assert(!s.equals(o)):"Should not remove object from its own hbSet.";
		 if ( s.equals(o) ) return;
		 
		 int set = get_hash_row_index(s);
		 int obj = get_hash_column_index(o);
		 assert(set != Log.EMPTY):"Cannot find slot for \""+s+"\"";
		 assert(obj != Log.EMPTY):"Cannot find slot for \""+o+"\"";
		 
		 if ( hb[set] != null && hb[set].length > (obj/8) )
		 {
			 byte mask = (byte)~(0x80 >> obj%8);
			 hb[set][obj/8] &= mask;
		 }
	 }
	 
	
	 
	/*
	 * BASIC HB METHODS
	 */
	public void norace(Key t, Key o)
	{
		Log.logHBSet("\t\t"+"\t<norace("+t+"->"+o+")>");
		
		if ( !verify(t, o) )
		{
			Log.logResult("DATA RACE on "+o+" by "+t+".");
			Log.logResult("\tKey_Set("+o+")="+get_key_set(o));
			if ( is_hb_member(o) )
				Log.logResult("\tHB_Set("+o+")="+get_hb_set(o));
			else
				Log.logResult("\tHB_Set("+o+")=not allocated");	

			HBDataRaceException.handle(t, o);
		}
	}
	
	public boolean verify(Key a, Key o)
	{
		int set = get_hash_row_index(a);
		int obj = get_hash_column_index(o);
		assert(set != Log.EMPTY):"Cannot find slot for \""+a+"\"";
		
		assert(obj != Log.EMPTY):"Cannot find slot for \""+o+"\"";
		
		if ( set == obj ) return true; // always have self
		if ( (hb[set] == null) || 
			 (hb[set].length <= obj/8) || 
			 ( (hb[set][obj/8] & (byte)(0x80 >> obj%8)) == 0) )
			return false;
		else
			return true;
	}
	
	public void acquire(Key t, Key o)
	{
		 Log.logHBSet("\t\t"+"\t<acquire("+t+"->"+o+")>");
		 int set = get_hash_row_index(t);
		 int obj = get_hash_row_index(o);
		 assert(set != Log.EMPTY) :"Cannot find slot for \""+t+"\"";
		 assert(obj != Log.EMPTY) :"Cannot find slot for \""+o+"\"";
		 
		 if ( hb[obj] != null )
		 {
			 if ( hb[set] == null )
				 hb[set] = new byte[hb[obj].length];
			 
			 else if ( hb[set].length < hb[obj].length )
			 {
				 byte[] tmp = new byte[hb[obj].length];
				 System.arraycopy(hb[set], 0, tmp, 0, hb[set].length);
				 hb[set] = tmp;
			 }
			 
			 for ( int i=0 ; i < hb[obj].length ; ++i )
			 {
				 hb[set][i] |= hb[obj][i];
			 }
		 }
		 if ( get_hash_column_index(o) != Log.EMPTY )
			 add(t, o);
	}
	
	public void release(Key t, Key o)
	{
		Log.logHBSet("\t\t"+"\t<release("+t+"->"+o+")>");
		 int set = get_hash_row_index(o);
		 int obj = get_hash_row_index(t);
		 
		 assert(set != Log.EMPTY) :"Cannot find slot for \""+o+"\"";
		 assert(obj != Log.EMPTY) :"Cannot find slot for \""+t+"\"";
		 
		 if ( hb[obj] != null )
		 {
			 if ( hb[set] == null )
				 hb[set] = new byte[hb[obj].length];
			 else if ( hb[set].length < hb[obj].length )
			 {
				 byte[] tmp = new byte[hb[obj].length];
				 System.arraycopy(hb[set], 0, tmp, 0, hb[set].length);
				 hb[set] = tmp;
			 }
			 
			 for ( int i=0 ; i < hb[obj].length ; ++i )
				 hb[set][i] |= hb[obj][i];
		 }
		 if ( get_hash_column_index(o) != Log.EMPTY )
			 add(t, o);
	}
	
	public void invalidate(Key t, Key o)
	{
		Log.logHBSet("\t\t"+"\t<invalidate("+t+"->"+o+")>");
		for ( int i=0 ; i < row_index ; ++i )
		{
			if ( !t.equals(hb_row[i])  && !o.equals(hb_row[i]) )
				remove(hb_row[i], o);
		}
	}
}
