package jrf.hbset.util;

import gov.nasa.jpf.jvm.JVM;


public class Configuration {
	
	/*
	 * dealing with Benign Race
	 */
	private static final String benignRaceLocation[] = Configuration.get_benign_race();
	
	private static String[] get_benign_race()
	{
		String benignRace = JVM.getVM().getConfig().getProperty("jrf.benign");
//System.out.println("### BENIGN RACE="+benignRace);
		return benignRace==null?null:benignRace.split(",");
	}
	
	public static boolean isBenign(String src)
	{
		for ( int i=0 ; i < benignRaceLocation.length ; ++i )
			if ( benignRaceLocation[i].trim().equals(src) ) return true;
		return false;
	}
	

	/*
	 * dealing with Trusted Class
	 */
	private static final String excluding[] = get_excluding_path();
	
	private static String[] get_excluding_path()
	{
		String excludingPath=null;
//try{
		boolean isInteresting = JVM.getVM().getConfig().getBoolean("jrf.excluding");
		if ( !isInteresting ) return null;
		excludingPath = JVM.getVM().getConfig().getProperty("jrf.excluding.path");
		return excludingPath==null?null:excludingPath.split(",");
//} finally {
//	System.out.println("### Excluding Path="+excludingPath);
//}
	}
	
	public static boolean isInteresting(String src)
	{
		// not using excluding path option
		if ( excluding == null ) return true;
		
		
		String path;
		if ( Utility.isArray(src) )
		{
			if ( Utility.isPrimitiveArray(src) )
			{
				Key o = new Key(src, 0);
				path = o.getLocation();
				if ( path==null ) path = HBDataRaceException.getSourceLocation();
			}
			else
				path = src.substring(src.lastIndexOf("[L")+2);
		}
		else 
			path = src;
	
		if ( path.lastIndexOf("\" at ") != -1 )
			path = path.substring(path.lastIndexOf("\" at ")+5);
		
		for ( int i=0 ; i < excluding.length ; ++i )
			if ( path.trim().startsWith(excluding[i].trim()) )	return false;
	
		return true;
	}
}
