package jrf.listener;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.concurrent.TimeUnit;

import gov.nasa.jpf.Config;
import gov.nasa.jpf.jvm.JVM;
import gov.nasa.jpf.report.Statistics;
import gov.nasa.jpf.search.Search;

public class JPFPreciseRaceDetector extends gov.nasa.jpf.listener.PreciseRaceDetector {

	public JPFPreciseRaceDetector (Config conf) {
	    super(conf);
	  }
	
 	 static long  startTime = System.nanoTime();
 	 
 	
  	 private void writeResultToFile()
	 { 	 
  		 String resultFile = "result/RESULT";
  		 long duration = TimeUnit.SECONDS.convert((System.nanoTime()-startTime), TimeUnit.NANOSECONDS);
		 String detectionT = new String((duration/3600)+":"+((duration%3600)/60)+":"+(duration%60));
  		 try {
  			 PrintWriter pw = new PrintWriter(new FileOutputStream(resultFile, true));

  			 Config config = JVM.getVM().getConfig();
  			 Statistics stat = JVM.getVM().getJPF().getReporter().getStatistics();
  			 
  			 String msg = config.getTarget();
  			 msg += " , "+"JPF";
  			 msg += " , "+stat.newStates;
  			 msg += " , "+0;
  			 msg += " , "+JVM.getVM().getPathLength();
  			 msg += " , "+detectionT+"s";
  			 msg += " , "+(stat.maxUsed >>20) + "MB";
  			 msg += " , ";
  			 String raceLocation = getErrorMessage();
  			 int i = raceLocation.indexOf("race for field");
  			 if ( i >= 0 )
  				raceLocation = raceLocation.substring(i+"race for field".length());
  			 String field = raceLocation.substring(0, raceLocation.indexOf('\n'));
  			 i = raceLocation.indexOf("(");
  			 if ( i >= 0 )
  				raceLocation = raceLocation.substring(i+1);
  			 String loc;
  			 i = raceLocation.indexOf(")");
  			 loc = raceLocation.substring(0, i);
  			 raceLocation = raceLocation.substring(i+1);
  			
  			i = raceLocation.indexOf("(");
 			 if ( i >= 0 )
 				raceLocation = raceLocation.substring(i+1);
 			i = raceLocation.indexOf(")");
 			if ( i >= 0 )
 				raceLocation = raceLocation.substring(0,i);
 			raceLocation = loc==null?raceLocation:loc+","+raceLocation;
  			 msg += " , ("+field.trim()+")"+raceLocation; 
  	 System.err.println("PreciseRaceDetectorResult = "+msg+"\n\n");			 
  			 pw.println(msg);
  			 pw.flush();
  		 } catch (FileNotFoundException e) {
  			 e.printStackTrace();
  		 }
	 }
 	 
 	public void searchFinished (Search search) {
 	    writeResultToFile();
 	  }
}
