package jrf.search;

import gov.nasa.jpf.Config;
import gov.nasa.jpf.jvm.JVM;
import gov.nasa.jpf.search.heuristic.SimplePriorityHeuristic;
import gov.nasa.jpf.search.heuristic.StaticPriorityQueue;
import jrf.hbset.ListenerHBmanagement;
import jrf.listener.HBSearchListener;

public class HBBFSearch extends HBPriorityHeuristic implements HBSearch {
	
	 public HBBFSearch(Config config, JVM vm) {
		super(config, vm);
		ListenerHBmanagement.setRestore_FIFO_Order();
	}
	protected int computeHeuristicValue () {
		    int priority = vm.getPathLength();

		    return priority;
		  }
	 @Override
	  protected boolean forward () {
		    boolean isForward = super.forward();
		    
		    if ( isForward && !isNewState() ) 
		    	this.isNewState = !HBSearchListener.isCoveredState(vm.getStateId(), false);//true;
		    return isForward;   
	  }
	  
	  
	  @Override
	  protected boolean generateChildren (int maxDepth) {
	//	 System.out.println("HBSearchListener:  >> in generateChildren "+vm.getStateId()); 
		  if ( !HBSearchListener.isFirstVisit(vm.getStateId()) && HBSearchListener.isCoveredState(vm.getStateId(), true) )
		  {
		//	  System.out.println("HBSearchListener:  >> isCovered=true for "+vm.getStateId()); 
			  return true;
		  }
		  else
		  {
		//	  System.out.println("HBSearchListener:  >> isCovered=false for "+vm.getStateId());
			  return super.generateChildren(maxDepth);
		  }
	  }
}
